#!/bin/bash

set -e

psql -c "create table if not exists ab (a int, b int);" postgres

#for rows in 1000000 10000000
for rows in 1000000
do
	for mod in 1 2 3 6 10 18 32 56 100 178 316 562 1000 1778 3162 5623 10000
	do
#		for dist in unsorted presorted random
		for dist in random
		do
			psql -c "truncate table ab;" postgres > /dev/null
			case $dist in
				unsorted ) selectrows="select x%$mod,x from generate_Series(1,$rows) x;" ;;
				presorted ) selectrows="select x / ($rows / $mod) ,x from generate_Series(1,$rows) x;" ;;
				random ) selectrows="select x % $mod * random(),x from generate_Series(1,$rows) x;" ;;
			esac
			psql -c "insert into ab $selectrows" postgres > /dev/null
			psql -c "vacuum freeze ab;" postgres > /dev/null
			psql -c "select pg_prewarm('ab');" postgres > /dev/null
			echo "select a,b,row_number() over (order by a) from ab order by a,b" > bench.sql
			
			for pushdown in off on
			do
				psql -c "alter system set enable_sort_pushdown = $pushdown;" postgres > /dev/null
				psql -c "select pg_reload_conf();" postgres > /dev/null
				echo -n "$rows $mod $dist $pushdown "
				pgbench -n -f bench.sql -T 10 -M prepared postgres | grep latency
			done
		done
	done
done
